/* Debug Header */
#if DEBUG
# define IFDEBUG(x) do { if (debug) x; }while(0)
# define IFDEBUG5(x) do { if (debug) x; }while(0)
#else
# define IFDEBUG(x)
# define IFDEBUG5(x)
#endif
/* End Debug Header */

#include <strings.h>
#include <stdio.h>
#include <stdarg.h>
#include <stdlib.h>
#include <sys/types.h>
#include "extern.h"

int print_debug(int level, char *fmt, ...) {
	
	int i;
	char c, *p, *s;
	char *t, *str, *memp;
	va_list args;

	memp=str=(char *)strdup(fmt);
	if (debug>=level) {
		fprintf(stdout, "Debug[%i]: ", level);
		va_start(args, fmt);
		while(*str) {
			t=str;
			t=(char *)strchr(t, '%');
			if (!t) break;
			*t='\0';
			if (str) fprintf(stdout, str);
			t++;
			str=t;
			switch(*str++) {
				case 's':
					s = va_arg(args, char *);
					fprintf(stdout, "%s", s);
					break;
				case 'i':
					i = va_arg(args, int);
					fprintf(stdout, "%i", i);
					break;
				case 'c':
					c = (char) va_arg(args, int);
					fprintf(stdout, "%c", c);
					break;
				case 'p':
					s = va_arg(args, char *);
					fprintf(stdout, "%p", s);
					break;
			}
			va_end(args);
		}
		if (str) fprintf(stdout, str);
		// printf("\n");
	}
	free(memp);
	fflush(stderr);
	fflush(stdout);
}
